<section
  class="l-body l-body--full-width mat-elevation-z0"
  *ngIf="paginator$ | async as paginator"
>
  <header class="page-header">
    <gt-list-title
      title="Transaction Groups"
      [searchHits]="paginator.count"
    ></gt-list-title>
  </header>
  <gt-project-filter-bar></gt-project-filter-bar>
  <div *ngIf="transactionGroupsDisplay$ | async as transactionGroups">
    <table
      mat-table
      class="mat-elevation-z2"
      [dataSource]="transactionGroupsDisplay$"
    >
      <ng-container matColumnDef="actions">
        <th
          mat-header-cell
          *matHeaderCellDef
          [attr.colspan]="displayedColumns.length"
          class="table-header"
        >
          <ng-container
            *ngIf="
              organizationEnvironments$ | async as organizationEnvironments
            "
          >
            <gt-data-filter-bar
              [dateForm]="dateForm"
              [environmentForm]="environmentForm"
              [sortForm]="sortForm"
              [searchForm]="searchForm"
              [sorts]="sorts"
              [organizationEnvironments]="organizationEnvironments"
              (dateFormSubmission)="onDateFormSubmit($event)"
              (dateFormReset)="dateFormReset()"
              (filterByEnvironment)="filterByEnvironment($event)"
              (sortByChanged)="sortByChanged($event)"
              (searchSubmit)="searchSubmit()"
            ></gt-data-filter-bar>
          </ng-container>
        </th>
      </ng-container>

      <ng-container matColumnDef="name-and-project">
        <th mat-header-cell *matHeaderCellDef>Title</th>
        <td mat-cell *matCellDef="let group">
          <div class="name-and-project">
            <div
              class="group-title"
              (mouseover)="checkIfTooltipIsNecessary($event)"
            >
              <span
                matTooltipPosition="above"
                [matTooltip]="setTitleTooltip(group)"
                [matTooltipDisabled]="tooltipDisabled"
              >
                <a [routerLink]="group.id" queryParamsHandling="merge">
                  <span *ngIf="group.method">{{ group.method }}&nbsp;</span
                  >{{ group.transaction }}<span *ngIf="!group.method">;</span>
                </a>
                <span *ngIf="!group.method">&nbsp;{{ group.op }}</span>
              </span>
            </div>
            <div class="mat-caption">
              <span *ngIf="(appliedProjectCount$ | async) !== 1">
                {{ group.projectSlug }}
              </span>
              <span>
                <ng-container *ngIf="(appliedProjectCount$ | async) !== 1">
                  &mdash;
                </ng-container>
                {{
                  group.transactionCount
                    | i18nPlural : transactionCountPluralMapping
                }}
              </span>
            </div>
          </div>
        </td>
      </ng-container>
      <ng-container matColumnDef="avgDuration">
        <th mat-header-cell *matHeaderCellDef>Average Duration</th>
        <td
          mat-cell
          *matCellDef="let group"
          class="avg-duration-cell mat-body-1"
        >
          {{ group.avgDuration | humanizeDuration }}
        </td>
      </ng-container>
      <ng-container matColumnDef="pagination">
        <td
          mat-footer-cell
          *matFooterCellDef
          [attr.colspan]="displayedColumns.length"
          class="footer"
        >
          <gt-list-footer [paginator]="paginator"> </gt-list-footer>
        </td>
      </ng-container>
      <tr mat-header-row *matHeaderRowDef="['actions']"></tr>
      <tr
        mat-header-row
        class="overlay"
        *matHeaderRowDef="displayedColumns"
        [class.u-hidden]="transactionGroups.length === 0"
      ></tr>
      <tr
        mat-row
        *matRowDef="let row; columns: displayedColumns"
        class="monitor-row"
      ></tr>
      <tr class="mat-row" *matNoDataRow>
        <td class="mat-cell" [attr.colspan]="displayedColumns.length">
          <div class="empty-states">
            <ng-container
              *ngIf="
                (initialLoadComplete$ | async) === true &&
                (loading$ | async) === false
              "
            >
              <ng-container *ngIf="(errors$ | async)?.length; else noResults">
                <ng-container
                  *ngIf="(errors$ | async)?.length === 1; else multipleErrors"
                  ><h3 class="mat-headline-4">
                    There was an error processing your request
                  </h3></ng-container
                ><ng-template #multipleErrors
                  ><h3 class="mat-headline-4">
                    There were errors while processing your request
                  </h3></ng-template
                >
                <ul>
                  <li *ngFor="let error of errors$ | async">{{ error }}</li>
                </ul>
              </ng-container>
              <ng-template #noResults>
                No transaction groups were found.
              </ng-template>
            </ng-container>
          </div>
        </td>
      </tr>
      <tr
        mat-footer-row
        class="pagination-row"
        *matFooterRowDef="['pagination']"
      ></tr>
    </table>
  </div>
</section>
